
#ifndef UTIL_PODITERATORBASE_HPP
#define UTIL_PODITERATORBASE_HPP

#include <boost/preprocessor.hpp>

#define SEQ_ENUM_REPEAT(a, b, c) BOOST_PP_SEQ_ENUM(BOOST_PP_REPEAT(a, b, c))

template <typename Derived, typename Pod>
struct PodIteratorBase
{
  template <typename T0, T0 (Pod:: * M0)> bool operator() (char const n0 [])
  { return static_cast<Derived *>(this)->template process<T0, M0>(n0); }

  #define H0(z, n, data) (typename BOOST_PP_CAT(T, n))(BOOST_PP_CAT(T, n) (Pod:: * BOOST_PP_CAT(M, n)))
  #define H1(z, x, data) (char const BOOST_PP_CAT(n, x) [])
  #define H2(z, x, data) (BOOST_PP_CAT(T, BOOST_PP_INC(x)))(BOOST_PP_CAT(M, BOOST_PP_INC(x)))
  #define H3(z, x, data) (BOOST_PP_CAT(n, BOOST_PP_INC(x)))
  #define H4(z, n, data) \
    template <SEQ_ENUM_REPEAT(BOOST_PP_INC(n), H0, ~)> \
    bool operator() ( SEQ_ENUM_REPEAT(BOOST_PP_INC(n), H1, ~) ) \
    { return operator()<T0, M0>(n0) && operator()<SEQ_ENUM_REPEAT(n, H2, ~)>(SEQ_ENUM_REPEAT(n, H3, ~)); }
  #define H5(z, n, data) H4(z, BOOST_PP_ADD(n, 1), data)

  BOOST_PP_REPEAT(12, H5, ~)

  #undef H0
  #undef H1
  #undef H2
  #undef H3
  #undef H4
  #undef H5
};

#endif // header guard

