
#ifndef POD_DEFINITION_HPP
#define POD_DEFINITION_HPP

#include "OverloadTag.hpp"

#include <boost/preprocessor.hpp>

#define POD_DEFINE_H0(r, data, elem) BOOST_PP_TUPLE_ELEM(2, 0, elem) BOOST_PP_TUPLE_ELEM(2, 1, elem);
#define POD_DEFINE_H1(s, data, elem) (BOOST_PP_TUPLE_ELEM(2, 0, elem)) (&data:: BOOST_PP_TUPLE_ELEM(2, 1, elem))
#define POD_DEFINE_H2(s, data, elem) BOOST_PP_STRINGIZE(BOOST_PP_TUPLE_ELEM(2, 1, elem))

#define POD_DEFINE(name, members) \
  struct name { BOOST_PP_SEQ_FOR_EACH(POD_DEFINE_H0, ~, members) }; \
  template <typename Fwd> void pod_members (Fwd & fwd, OverloadTag<name>) \
  { fwd.template operator()<BOOST_PP_SEQ_ENUM(BOOST_PP_SEQ_FOR_EACH(POD_DEFINE_H1, name, members))>( \
   BOOST_PP_SEQ_ENUM(BOOST_PP_SEQ_TRANSFORM(POD_DEFINE_H2, ~, members))  ); }

#endif // header guard
